/*
 *  arch/mips/emma3tl/e21/led.c
 *      This file defines the led display for E21.
 *
 * Author: NEC Electronics Corporation
 *
 * Copyright (C) 2008 NEC Electronics Corporation
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#include <linux/kernel.h>
#include <linux/types.h>
#include <linux/string.h>
#include <asm/emma3tl/emma3tl.h>

const unsigned long clear = 0x20202020;

#define LED_BASE 0xb1400130

void e21_led_clear(void)
{
#if 0
	emma_out32(LED_BASE + 0x0, clear);
	emma_out32(LED_BASE + 0x4, clear);
	emma_out32(LED_BASE + 0x8, clear);
	emma_out32(LED_BASE + 0xc, clear);
#endif
}

void e21_led(const char *str)
{
#if 0
	int i;
	int len = strlen(str);

	e21_led_clear();
	if (len > 8)
		len = 8;

	if (emma_in32(0xb0000800) & (0x3 << 24))
		for (i = 0; i < len; i++)
			emma_out16(LED_BASE + i * 2, str[i]);
#endif
}

void e21_led_hex(u32 val)
{
#if 0
	char str[10];

	sprintf(str, "%08x", val);
	e21_led(str);
#endif
}
