/*
 *  include/asm-mips/emma3tl/emma3tl.h
 *      This file is EMMA3TL common header.
 *
 * Author: NEC Electronics Corporation
 *
 * Copyright (C) 2008 NEC Electronics Corporation
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 *  This file based on include/asm-mips/ddb5xxx/ddb5xxx.h
 *          Copyright 2001 MontaVista Software Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#ifndef __ASM_EMMA3TL_EMMA3TL_H
#define __ASM_EMMA3TL_EMMA3TL_H

/*
 * EMMA3TL2 registers
 */
#define REGBASE 0x10000000

#define EMMA_BHIF_BASE		(0x0000+REGBASE)
#define EMMA_ROMIF_BASE		(0xa000+REGBASE) /* EMMA2TLでは 0xb0000400 だったが EMMA3TL2Sでは 0xb000a000 へ変更されている */
#define EMMA_ETHER_BASE 	(0x012000+REGBASE)
#define EMMA_PBRD_BASE		(0x100000+REGBASE)
#define EMMA_TIMER_BASE		(0x110000+REGBASE)
#define EMMA_PRCG_BASE		(0x111200+REGBASE)

#define EMMA_BHIF_STRAP_0	(0x0010+EMMA_BHIF_BASE)
#define EMMA_BHIF_STRAP_0_W	(0x0020+EMMA_BHIF_BASE)
#define EMMA_BHIF_ALTERNATE0	(0x0028+EMMA_BHIF_BASE)
#define EMMA_BHIF_ALTERNATE1	(0x002c+EMMA_BHIF_BASE)
#define EMMA_BHIF_INT_ST_0	(0x0030+EMMA_BHIF_BASE)
#define EMMA_BHIF_INT_ST_1	(0x0034+EMMA_BHIF_BASE)
#define EMMA_BHIF_INT_ST_2	(0x0038+EMMA_BHIF_BASE)
#define EMMA_BHIF_INT0_EN_0	(0x0040+EMMA_BHIF_BASE)
#define EMMA_BHIF_INT0_EN_1	(0x0044+EMMA_BHIF_BASE)
#define EMMA_BHIF_INT0_EN_2	(0x0048+EMMA_BHIF_BASE)
#define EMMA_BHIF_INT1_EN_0	(0x0050+EMMA_BHIF_BASE)
#define EMMA_BHIF_INT1_EN_1	(0x0054+EMMA_BHIF_BASE)
#define EMMA_BHIF_INT1_EN_2	(0x0058+EMMA_BHIF_BASE)
#define EMMA_BHIF_SUB_INT_ST_0	(0x0100+EMMA_BHIF_BASE)
#define EMMA_BHIF_SUB_INT_ST_1	(0x0104+EMMA_BHIF_BASE)
#define EMMA_BHIF_SUB_INT_ST_2	(0x0108+EMMA_BHIF_BASE)
#define EMMA_BHIF_SUB_INT0_EN_0	(0x0110+EMMA_BHIF_BASE)
#define EMMA_BHIF_SUB_INT0_EN_1	(0x0114+EMMA_BHIF_BASE)
#define EMMA_BHIF_SUB_INT0_EN_2	(0x0118+EMMA_BHIF_BASE)
#define EMMA_BHIF_SUB_INT1_EN_0	(0x0120+EMMA_BHIF_BASE)
#define EMMA_BHIF_SUB_INT1_EN_1	(0x0124+EMMA_BHIF_BASE)
#define EMMA_BHIF_SUB_INT1_EN_2	(0x0128+EMMA_BHIF_BASE)
#define EMMA_BHIF_SW_INT0	(0x01a0+EMMA_BHIF_BASE)
#define EMMA_BHIF_SW_INT0_EN	(0x01a4+EMMA_BHIF_BASE)
#define EMMA_BHIF_SW_INT0_CLR	(0x01a8+EMMA_BHIF_BASE)
#define EMMA_BHIF_AADC_CTRL_0	(0x03c0+EMMA_BHIF_BASE)

#define EMMA_PURT0_BASE		(0x1000+EMMA_PBRD_BASE)
#define EMMA_PURT1_BASE		(0x2000+EMMA_PBRD_BASE)
#define EMMA_PURT2_BASE		(0x3000+EMMA_PBRD_BASE)

#define EMMA_PIIC0_BASE		(0x4000+EMMA_PBRD_BASE)
#define EMMA_PIIC1_BASE		(0x5000+EMMA_PBRD_BASE)
#define EMMA_PIIC2_BASE		(0x6000+EMMA_PBRD_BASE)

#define EMMA_PRCG0_CTRL		(0x00+EMMA_PRCG_BASE)
#define EMMA_PRCG0_PARA		(0x04+EMMA_PRCG_BASE)

/* GPIO */
#define EMMA_GPIO_BASE			(0x0d00+EMMA_TIMER_BASE)
#define	EMMA_GPIO_DATA_BASE		(0x00+EMMA_GPIO_BASE)
#define	EMMA_GPIO_DIR_LOW		(0xc0+EMMA_GPIO_BASE)
#define	EMMA_GPIO_DIR_HIG		(0xc4+EMMA_GPIO_BASE)
#define EMMA_GPIO2_NUM_OFS		(48)
#define EMMA_GPIO2_BASE			(0x0e00+EMMA_TIMER_BASE)
#define	EMMA_GPIO2_DATA_BASE	(0x00+EMMA_GPIO2_BASE)
#define	EMMA_GPIO2_DIR			(0xc0+EMMA_GPIO2_BASE)
#define EMMA_GPIO_NUM_MAX		(78)

/* Use SubCPU */
#ifdef CONFIG_EMMA_SUBCPU
#undef EMMA_BHIF_INT_ST_0
#undef EMMA_BHIF_INT_ST_1
#undef EMMA_BHIF_INT_ST_2
#undef EMMA_BHIF_INT0_EN_0
#undef EMMA_BHIF_INT0_EN_1
#undef EMMA_BHIF_INT0_EN_2
#undef EMMA_BHIF_INT1_EN_0
#undef EMMA_BHIF_INT1_EN_1
#undef EMMA_BHIF_INT1_EN_2
#define EMMA_BHIF_INT_ST_0	EMMA_BHIF_SUB_INT_ST_0
#define EMMA_BHIF_INT_ST_1	EMMA_BHIF_SUB_INT_ST_1
#define EMMA_BHIF_INT_ST_2	EMMA_BHIF_SUB_INT_ST_2
#define EMMA_BHIF_INT0_EN_0	EMMA_BHIF_SUB_INT0_EN_0
#define EMMA_BHIF_INT0_EN_1	EMMA_BHIF_SUB_INT0_EN_1
#define EMMA_BHIF_INT0_EN_2	EMMA_BHIF_SUB_INT0_EN_2
#define EMMA_BHIF_INT1_EN_0	EMMA_BHIF_SUB_INT1_EN_0
#define EMMA_BHIF_INT1_EN_1	EMMA_BHIF_SUB_INT1_EN_1
#define EMMA_BHIF_INT1_EN_2	EMMA_BHIF_SUB_INT1_EN_2
#endif

/*
 *  Memory map (physical address)
 *
 *  Note most of the following address must be properly aligned by the
 *  corresponding size.  For example, if PCI_IO_SIZE is 16MB, then
 *  PCI_IO_BASE must be aligned along 16MB boundary.
 */

/* the actual ram size is detected at run-time */
#define EMMA_RAM_BASE		0x00000000

#define EMMA_RAM_SIZE		0x05600000	/* 86 MB */

#define EMMA_IO_BASE		0x10000000
#define EMMA_IO_SIZE		0x01000000	/* 16 MB */

#define EMMA_GENERALIO_BASE	0x11000000
#define EMMA_GENERALIO_SIZE	0x01000000	/* 16 MB */

#define EMMA_NAND_BASE		0x1c000000
#define EMMA_NAND_SIZE		0x10000000	/* 256 MB */

#define NUM_CPU_IRQ			8
#define NUM_EMMA_IRQ		96
#define NUM_EMMA_IRQ_SW		32

#define CPU_IRQ_BASE		0
#define EMMA_IRQ_BASE		(CPU_IRQ_BASE + NUM_CPU_IRQ)
#define EMMA_SW_IRQ_BASE	(EMMA_IRQ_BASE + NUM_EMMA_IRQ)

/*
 * emma3tl irq defs
 */

#define EMMA_IRQ_INT00		(0 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT01		(1 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT02		(2 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT03		(3 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT04		(4 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT05		(5 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT06		(6 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT07		(7 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT08		(8 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT09		(9 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT10		(10 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT11		(11 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT12		(12 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT13		(13 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT14		(14 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT15		(15 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT16		(16 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT17		(17 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT18		(18 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT19		(19 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT20		(20 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT21		(21 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT22		(22 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT23		(23 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT24		(24 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT25		(25 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT26		(26 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT27		(27 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT28		(28 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT29		(29 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT30		(30 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT31		(31 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT32		(32 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT33		(33 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT34		(34 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT35		(35 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT36		(36 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT37		(37 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT38		(38 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT39		(39 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT40		(40 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT41		(41 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT42		(42 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT43		(43 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT44		(44 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT45		(45 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT46		(46 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT47		(47 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT48		(48 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT49		(49 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT50		(50 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT51		(51 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT52		(52 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT53		(53 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT54		(54 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT55		(55 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT56		(56 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT57		(57 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT58		(58 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT59		(59 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT60		(60 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT61		(61 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT62		(62 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT63		(63 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT64		(64 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT65		(65 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT66		(66 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT67		(67 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT68		(68 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT69		(69 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT70		(70 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT71		(71 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT72		(72 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT73		(73 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT74		(74 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT75		(75 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT76		(76 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT77		(77 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT78		(78 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT79		(79 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT80		(80 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT81		(81 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT82		(82 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT83		(83 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT84		(84 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT85		(85 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT86		(86 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT87		(87 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT88		(88 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT89		(89 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT90		(90 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT91		(91 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT92		(92 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT93		(93 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT94		(94 + EMMA_IRQ_BASE)
#define EMMA_IRQ_INT95		(95 + EMMA_IRQ_BASE)

#define EMMA_SW_IRQ_INT00	(0 + EMMA_SW_IRQ_BASE)
#define EMMA_SW_IRQ_INT01	(1 + EMMA_SW_IRQ_BASE)
#define EMMA_SW_IRQ_INT02	(2 + EMMA_SW_IRQ_BASE)
#define EMMA_SW_IRQ_INT03	(3 + EMMA_SW_IRQ_BASE)
#define EMMA_SW_IRQ_INT04	(4 + EMMA_SW_IRQ_BASE)
#define EMMA_SW_IRQ_INT05	(5 + EMMA_SW_IRQ_BASE)
#define EMMA_SW_IRQ_INT06	(6 + EMMA_SW_IRQ_BASE)
#define EMMA_SW_IRQ_INT07	(7 + EMMA_SW_IRQ_BASE)
#define EMMA_SW_IRQ_INT08	(8 + EMMA_SW_IRQ_BASE)
#define EMMA_SW_IRQ_INT09	(9 + EMMA_SW_IRQ_BASE)
#define EMMA_SW_IRQ_INT10	(10 + EMMA_SW_IRQ_BASE)
#define EMMA_SW_IRQ_INT11	(11 + EMMA_SW_IRQ_BASE)
#define EMMA_SW_IRQ_INT12	(12 + EMMA_SW_IRQ_BASE)
#define EMMA_SW_IRQ_INT13	(13 + EMMA_SW_IRQ_BASE)
#define EMMA_SW_IRQ_INT14	(14 + EMMA_SW_IRQ_BASE)
#define EMMA_SW_IRQ_INT15	(15 + EMMA_SW_IRQ_BASE)
#define EMMA_SW_IRQ_INT16	(16 + EMMA_SW_IRQ_BASE)
#define EMMA_SW_IRQ_INT17	(17 + EMMA_SW_IRQ_BASE)
#define EMMA_SW_IRQ_INT18	(18 + EMMA_SW_IRQ_BASE)
#define EMMA_SW_IRQ_INT19	(19 + EMMA_SW_IRQ_BASE)
#define EMMA_SW_IRQ_INT20	(20 + EMMA_SW_IRQ_BASE)
#define EMMA_SW_IRQ_INT21	(21 + EMMA_SW_IRQ_BASE)
#define EMMA_SW_IRQ_INT22	(22 + EMMA_SW_IRQ_BASE)
#define EMMA_SW_IRQ_INT23	(23 + EMMA_SW_IRQ_BASE)
#define EMMA_SW_IRQ_INT24	(24 + EMMA_SW_IRQ_BASE)
#define EMMA_SW_IRQ_INT25	(25 + EMMA_SW_IRQ_BASE)
#define EMMA_SW_IRQ_INT26	(26 + EMMA_SW_IRQ_BASE)
#define EMMA_SW_IRQ_INT27	(27 + EMMA_SW_IRQ_BASE)
#define EMMA_SW_IRQ_INT28	(28 + EMMA_SW_IRQ_BASE)
#define EMMA_SW_IRQ_INT29	(29 + EMMA_SW_IRQ_BASE)
#define EMMA_SW_IRQ_INT30	(30 + EMMA_SW_IRQ_BASE)
#define EMMA_SW_IRQ_INT31	(31 + EMMA_SW_IRQ_BASE)

#define CPU_EMMA_CASCADE	2
#define EMMA_SW_CASCADE		(EMMA_IRQ_INT06)

#define EMMA_IRQ_PUART0		(EMMA_IRQ_INT48)
#define EMMA_IRQ_PUART1		(EMMA_IRQ_INT49)
#define EMMA_IRQ_PUART2		(EMMA_IRQ_INT50)
#define EMMA_IRQ_PIIC0		EMMA_IRQ_INT51
#define EMMA_IRQ_PIIC1		EMMA_IRQ_INT52
#define EMMA_IRQ_PIIC2		EMMA_IRQ_INT53

#define EMMA_IRQ_ETHER		EMMA_IRQ_INT36
#define EMMA_IRQ_USB		EMMA_IRQ_INT33

/*
 *  EMMA Register Access
 */

#define EMMA_BASE 		(0xa0000000)

#ifndef __ASSEMBLY__
static inline void emma_sync(void)
{
	volatile u32 *p = (volatile u32 *)0xb0000000;
	(void)(*p);
	__asm__ __volatile__("sync");
}

static inline void emma_out32(u32 offset, u32 val)
{
	*(volatile u32 *)(EMMA_BASE | offset) = val;
	emma_sync();
}

static inline u32 emma_in32(u32 offset)
{
	u32 val = *(volatile u32 *)(EMMA_BASE | offset);
	emma_sync();
	return val;
}

static inline void emma_set32(u32 offset, u32 val)
{
	val |= emma_in32(offset);
	emma_out32(offset, val);
}

static inline void emma_clr32(u32 offset, u32 val)
{
	val &= emma_in32(offset);
	emma_out32(offset, val);
}

static inline void emma_out16(u32 offset, u16 val)
{
	*(volatile u16 *)(EMMA_BASE | offset) = val;
	emma_sync();
}

static inline u16 emma_in16(u32 offset)
{
	u16 val = *(volatile u16 *)(EMMA_BASE | offset);
	emma_sync();
	return val;
}

static inline void emma_set16(u16 offset, u16 val)
{
	val |= emma_in16(offset);
	emma_out16(offset, val);
}

static inline void emma_clr16(u16 offset, u16 val)
{
	val &= emma_in16(offset);
	emma_out16(offset, val);
}

static inline void emma_out8(u32 offset, u8 val)
{
	*(volatile u8 *)(EMMA_BASE | offset) = val;
	emma_sync();
}

static inline u8 emma_in8(u32 offset)
{
	u8 val = *(volatile u8 *)(EMMA_BASE | offset);
	emma_sync();
	return val;
}

static inline void emma_set8(u8 offset, u8 val)
{
	val |= emma_in8(offset);
	emma_out8(offset, val);
}

static inline void emma_clr8(u8 offset, u8 val)
{
	val &= emma_in8(offset);
	emma_out8(offset, val);
}

#endif

/*
 * include the board dependent part
 */
#if defined(CONFIG_E21)
#include <asm/emma3tl/e21.h>
#else
#error "Unknown EMMA3TL board!"
#endif

#endif	/* __ASM_EMMA3TL_EMMA3TL_H */
